<?php
namespace Planejamento\Entities;

use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Geral\Util\TratamentoDeMensagens;
use Setforms2\Shared\Registry;
use Geral\Entities\Servico;

class Confcard extends Base\Confcard
{

    public static function getConfiguracoesCardapio($nrorg, $cdfilial, $cdservfili) {
        $configsCard = \Planejamento\Entities\Confcard::getObjectsByWhere(
            'NRORG = ? AND CDFILIAL = ? AND CDSERVFILI = ?',
            array($nrorg, $cdfilial, $cdservfili)
        );

        return $configsCard;
    }


    public function insereConfPadrao($nrorg, $filial, $codigo, $cdTpPrato, $numPag, $ordem, $servico, $operador){
    	$this->setCdfilial($filial);
    	$this->setNrseqcnfcard($codigo);
    	$this->setCdtipoprat($cdTpPrato);
    	$this->setIdopccnfcard('N');
    	$this->setIdimpcnfcard('S');
    	$this->setNrpagcnfcard($numPag);
    	$this->setCdservfili($servico);
    	$this->setNrordcnfcard($ordem);
    	$this->setIdconcnfcard('S');
    	$this->setIdtppratferp('S');
    	$this->setIdtppratdomp('S');
    	$this->setIdtppratsegp('S');
    	$this->setIdtppratterp('S');
    	$this->setIdtppratquap('S');
    	$this->setIdtppratquip('S');
    	$this->setIdtppratsexp('S');
    	$this->setIdtppratsabp('S');
    	$this->setIdtppratextr('N');
    	$this->setIdvisutpextr('S');
    
    	$this->setNrorg($nrorg);
    	$this->setNrorginclusao($nrorg);
        $this->setNrorgultatu($nrorg);
    	$this->setDtinclusao(DateUtil::getDataAtual(true));
        $this->setDtultatu(DateUtil::getDataAtual(true));
        $this->setDtultatucfca(DateUtil::getDataAtual(true));
    	$this->setCdoperinclusao($operador);
        $this->setCdoperultatu($operador);
    
    	$this->persist();
    }
    
    
    public static function getUltimaOrdenacao($nrorg, $filial, $servico){
    	/** @var $obj Confcard */
    	$obj = self::getObjectByWhere(
    			"CDSERVFILI = ? AND NRORG = ?  AND CDFILIAL = ?",
    			array($servico, $nrorg, $filial),
    			"NRORDCNFCARD DESC"
    	);
    
    	if ($obj instanceof Confcard) {
    		return $obj->getNrordcnfcard();
    	} else {
    		return 0;
    	}
    }

    public static function atualizaConfCard($nrorg, $filial, $cdTipoPrato, $cdservfili, $nrseqcnfcard){
        $con = Registry::getEntityManager();
        $con->beginTransaction();

        try {
        $Confcard = Confcard::getObject(array('nrorg' => $nrorg, 'cdfilial' => $filial, 'cdservfili' => $cdservfili,
            'nrseqcnfcard' => $nrseqcnfcard));

        $Confcard->setCdfilial($filial);
        $Confcard->setNrorg($nrorg);
        $Confcard->setCdtipoprat($cdTipoPrato);
        $Confcard->setCdservfili($cdservfili);
        $Confcard->setNrseqcnfcard($nrseqcnfcard);
        $Confcard->setDtultatu(DateUtil::getDataAtual(true));
        $Confcard->setCdoperultatu(Ambiente::getCdOperador());
        $Confcard->setNrorgultatu($nrorg);
        $Confcard->persist();


        $con->flush();
        $con->commit();
        }catch (\Exception $e) {
            $con->rollback();
            Throw $e;
        }
    }

    public static function atualizaTipoPratoConfCard(
        $nrorg, $cdfilial, $cdservfili, $cdtipoprat, $nrseqcnfcard,
        $dscompltp, $idopccnfcard, $idimpcnfcard, $dsobscnfcard, $idconcnfcard,
        $operador, $dataAtual
    ) {
        $connection = Registry::getEntityManager();
        try {
            $connection->beginTransaction();
            //
            $registro = Confcard::getObjectByWhere(
                "NRORG = ? AND CDFILIAL = ? AND CDSERVFILI = ?
                 AND CDTIPOPRAT = ? AND NRSEQCNFCARD = ?",
                array($nrorg, $cdfilial, $cdservfili, $cdtipoprat, $nrseqcnfcard)
            );
            //
            $registro->setDscompltp($dscompltp);
            $registro->setIdopccnfcard($idopccnfcard);
            $registro->setIdimpcnfcard($idimpcnfcard);
            $registro->setDsobscnfcard($dsobscnfcard);
            $registro->setIdconcnfcard($idconcnfcard);
            //
            $registro->setNrorgultatu($nrorg);
            $registro->setDtultatu($dataAtual);
            $registro->setDtultatucfca(DateUtil::getDataAtual(true));
            $registro->setCdoperultatu($operador);
            //
            $connection->flush();
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            Throw $e;
        }

    }

    public static function clonaConfcard(Servico $servicoModelo, Servico $servicoNovo,  $conn){

            $codigomodelo = $servicoModelo->getCdservfili();
            $codigonovo = $servicoNovo->getCdservfili();
            $codigofilial = $servicoNovo->getCdfilial();
            $nrorg = Ambiente::getNrorg();
            $registrosConfcard = Confcard::getObjectsByWhere('
                NRORG = ? AND CDSERVFILI = ? AND CDFILIAL = ?',
                array($nrorg,$codigomodelo, $codigofilial ) );


            $operador = Ambiente::getCdOperador();
            $dtAtual = DateUtil::getDataAtual();
            if($registrosConfcard != false){
                /** @var $registronovo Confcard */
                foreach($registrosConfcard as $registromodelo){
                    $registronovo = clone $registromodelo;
                    $registronovo->setCdservfili($codigonovo);
                    $registronovo->setDtultatu($dtAtual);
                    $registronovo->setDtinclusao($dtAtual);
                    $registronovo->setCdoperinclusao($operador);
                    $registronovo->setCdoperultatu($operador);

                    $registronovo->persist();
                    $conn->flush();

                }
            }

    }

    public static function montaMensagemErroIntegridade($base, $constraint)
    {
        $sql = "SELECT TABLE_NAME AS FILHA, R_CONSTRAINT_NAME AS PAI FROM ALL_CONSTRAINTS
                WHERE CONSTRAINT_NAME = :P_CONSTRAINT
                AND OWNER = :P_OWNER";

        $params = array(
            'P_CONSTRAINT' => $constraint,
            'P_OWNER' => $base
        );

        $em = \Setforms2\Shared\Registry::getEntityManager();
        $result = $em->getConnection()->fetchAll($sql, $params);
        $message = tk_get_message_by_name('msg_ger04106_ExclusaoNaoPermitida', array($result[0]['FILHA']));

        return $message;
    }
      
}