<?php

/**
 * Parcnegocio
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     SetForms Team <development@setforms.com>
 * @version    Release: SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Parcnegocio extends DaoParcnegocio
{


    /**
     * Consulta registros de um determinado Parceiro de Negocio.
     *
     * @param integer $nrparceiro N?o de Parceiro.
     * @param integer $nrorg      N?o da Organiza?.
     *
     * @return ParcnegocioEntity
     *
     * @author brunofeliciano - 28/06/2011
     */
    public static function consultaParceiroNegocio($nrparceiro, $nrorg){
        try {
            $obj = self::getObjectByWhere(
                'NRPARCNEGOCIO = ? AND NRORG = ?',
                array(
                 $nrparceiro,
                 $nrorg,
                )
            );
            return $obj;
        } catch(Exception $e) {
            throw new Exception('Erro desconhecido (Parcnegocio): '.$e->getMessage());
            return false;
        }
    }


    /**
     * Retorna parceiro de negocio por tipo de inscricao.
     *
     * @param string  $tipoinscricao   Tipo de inscricao.
     * @param integer $nrinscricaoparc Numero de inscricao.
     * @param string  $tipoinscricao   Tipo do parceiro de negocio.
     *
     * @return ParcnegocioEntity
     *
     * @author brunofeliciano - 28/06/2011
     *         thalesvalias - 19/04/2012 - nome da funcao alterada; parametro $tipoinscricao adicionado
     */
    public static function retornaParceiroPorInscricao($cdtipoinscricao, $nrinscricaoparc, $nrorg){
        try {
            $obj = self::getObjectByWhere(
                'CDTIPOINSCRICAO = ? AND NRINSCRICAOPARC = ? AND NRORG = ?',
                array(
                 $cdtipoinscricao,
                 $nrinscricaoparc,
                 $nrorg
                )
            );
            return $obj;
        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false; 
       }
    }


    /**
     * Retorna o SQL de operadores respons?is pela situacao.
     *
     * @return $sql
     */
    public static function buscaParceirosOperadores(){
        $sql = "SELECT PN.NRPARCNEGOCIO,
                       PN.NMPRINCIPALPARC,
                       PN.NRORG
                  FROM PARCNEGOCIO PN
                 WHERE (PN.CDTIPOPARCPRINCIPAL = 'OPERADOR'
                    OR EXISTS
                      (SELECT *
                         FROM PARCERIA PA
                        WHERE PA.NRORG = PN.NRORG
                          AND PA.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
                          AND PA.CDTIPOPARCEIRO = 'OPERADOR'))
                 ORDER BY PN.NMPRINCIPALPARC";
        return $sql;
    }


    /**
     * Retorna Parceiro de Neg?s por tipo de parceiro principal.
     *
     * @param string $nrparceiro N?o do Parceiro de Neg?.
     * @param string $nrorg      N?o da Organiza?.
     * @param string $tipo_parc  Tipo Principal do Parceiro.
     *
     * @return Mixed<NULL, ParcnegocioEntity>
     */
    public static function retornaParceiroPorTipo($nrparceiro, $nrorg, $tipo_parc = null){
        try {
            $where = 'NRPARCNEGOCIO = ? AND NRORG = ? ';
            $params = array(
                       $nrparceiro,
                       $nrorg,
                      );
            if (isset($tipo_parc) === true) {
                $where .= 'AND CDTIPOPARCPRINCIPAL = ? ';
                $params[] = $tipo_parc;
            }

            $obj = self::getObjectByWhere($where, $params);
            return $obj;
        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
    * Retorna Query para Vendedor.
    *
    * @return string
    *
    * @author gustavosilva - 18/05/2012
    */
    public static function retornaQueryVendedor(){
        $sql = "SELECT PN.NRPARCNEGOCIO,
                       PN.NMPRINCIPALPARC,
                       PN.NRORG
                  FROM PARCNEGOCIO PN
                 WHERE (PN.CDTIPOPARCPRINCIPAL = 'VENDEDOR'
                    OR EXISTS
                      (SELECT *
                         FROM PARCERIA PA
                        WHERE PA.NRORG = PN.NRORG
                          AND PA.NRPARCNEGOCIO = PN.NRPARCNEGOCIO
                          AND PA.CDTIPOPARCEIRO = 'VENDEDOR'))
                 ORDER BY PN.NMPRINCIPALPARC";
        return $sql;
    }

    /**
    * Retorna numero de inscrição do parceiro.
    *
    * @param integer $nrparceiro N?o do Parceiro de Neg?.
    * @param integer $nrorg      N?o da Organiza?.
    *
    * @return array
    *
    * @author gustavosilva - 18/05/2012
    */
    public static function selectNrinscricaoParc($nrparcnegocio, $nrorg){
        try{
    		$select = "select nrinscricaoparc from parcnegocio where nrparcnegocio = ".$nrparcnegocio." and nrorg = ".$nrorg;
    		$array = \Setforms2\Runtime\Connection::getInstance()->fetchAll($select);
    		return $array;
    	} catch(Exception $e) {
             throw $e;
    	}


   }

    /**
    * Gera novo código.
    *
    * @return number
    *
    * @author gustavosilva - 18/05/2012
    */
    public static function geraNovoCodigoNrInscr()
    {
        return Novocodigo::geraCodigo(Ambiente::getNrorg(), 'VENDEDOR.NRINS', 5);
    }
        /**
         * Retorna tamanho em caracteres do numero de inscrição do parceiro.
         *
         * @param integer $nrparceiro N?o do Parceiro de Neg?.
         * @param integer $nrorg      N?o da Organiza?.
         *
         * @return number
         *
         * @author gustavosilva - 18/05/2012
         */
        public static function lenghNrInscricaoParc($nrparcnegocio, $nrorg){
       		 try{
    	    		$select = "select length(to_char(nrinscricaoparc)) from parcnegocio where nrparcnegocio = ".$nrparcnegocio." and nrorg = ".$nrorg;
    	    		$array = \Setforms2\Runtime\Connection::getInstance()->fetchAll($select);
    	    		return empty($array) ? null : $array[0]['LENGTH(TO_CHAR(NRINSCRICAOPARC))'];
    	    	}catch(Exception $e){
                    throw $e;
    	    	}
        }
    /**
     * Enter description herÜe ...
     *
     * @return string
     */

    public static function consultaOrcamentosDoParceiro($nrparcnegocio, $nrorg){

    	try{
    		$select = "select * from fct_orcamento where nrparcnegocio = ".$nrparcnegocio." and nrorg = ".$nrorg;
    		$array = \Setforms2\Runtime\Connection::getInstance()->fetchAll($select);
    		return $array;
    	}catch(Exception $e){
            throw $e;
    	}
    }

    public static function consultaTransportadoras($nrparc, $nrorg)
    {
        $sql = 'select T.* from FORNECEDOR F
                INNER JOIN TRANSPORT T ON (F.CDFORNECED = T.CDFORNECED AND F.NRORG = T.NRORG)
                WHERE F.NRPARCNEGOCIO = ? AND F.NRORG = ?';
                try{
            $db = \Setforms2\Runtime\Connection::getInstance();
            return $db->fetchAll($sql, array($nrparc, $nrorg));
        } catch(Exception $e) {
            throw $e;
        }
    }

        /**
     * Enter description here ...
     *
     * @param integer $nrparc Nº Parceiro.
     * @param integer $nrorg  Nº Organização.
     *
     * @return string
     */
    public static function retornaQuerySearchInterlocutor(){
        $sql = 'SELECT PARCNEGOCIO.* FROM
        (SELECT
        P.NMPRINCIPALPARC,P.NMSECUNDARIPARC, REPLACE(REPLACE(REPLACE(REPLACE(P.NRINSCRICAOPARC, \'.\',\'\'),\'/\',\'\'),\'-\',\'\'),\' \',\'\') AS NRINSCRICAOPARC,
        R.NRPARCNEGRELAC, R.NRPARCNEGOCIO,P.NRORG, P.CDTIPOPARCPRINCIPAL FROM PARCNEGOCIO P
        INNER JOIN RELACIONAPARC R
        ON P.NRPARCNEGOCIO = R.NRPARCNEGRELAC
        AND P.NRORG = R.NRORG
        WHERE R.NRTIPORELACIONA = 25) PARCNEGOCIO';

        return $sql;
    }

    public static function retornaQuerySearchParcnegocioComDadosComunicacao(){
        $sql = <<<SQL
SELECT PARCNEGOCIO.* FROM (SELECT CDSEGMER,
          P.NRPARCNEGOCIO,
          P.IDATIVO,
          P.NMPRINCIPALPARC,
          P.CDTIPOPARCPRINCIPAL,
          P.NRINSCRICAOPARC,
          REPLACE(REPLACE(REPLACE(REPLACE(P.NRINSCRICAOPARC, '.',''),'/',''),'-',''),' ','') AS INSCRICAOPARC,
          P.NMSECUNDARIPARC,
          P.NRORG,
          C.CDCOMUNICAPARC AS TELEFONE,
          CP.CDCOMUNICAPARC as EMAIL,
          E.DSENDERECO
        FROM PARCNEGOCIO P
        LEFT JOIN ENDERECOPARC E
        ON P.NRPARCNEGOCIO = E.NRPARCNEGOCIO
        AND P.NRORG = E.NRORG
        AND E.CDTIPOENDERECO = 'PRINCIPAL'
        LEFT JOIN COMUNICAPARC C
        ON P.NRPARCNEGOCIO  = C.NRPARCNEGOCIO
        AND P.NRORG = C.NRORG
        AND C.NRENDERECOPARC = E.NRENDERECOPARC
        AND C.CDFORMACOMU = 01
        LEFT JOIN COMUNICAPARC CP
        ON P.NRPARCNEGOCIO  = CP.NRPARCNEGOCIO
        AND P.NRORG = CP.NRORG
        AND CP.NRENDERECOPARC = E.NRENDERECOPARC
        AND CP.CDFORMACOMU = 05
        ) PARCNEGOCIO ORDER BY 4,8,7
SQL;
        return $sql;
    }

    /**
    * Retorna Query para popular searchTransportadora.
    *
    * @param integer $nrparceiro N?o do Parceiro de Neg?.
    * @param integer $nrorg      N?o da Organiza?.
    *
    * @return string
    *
    * @author gustavosilva - 18/05/2012
    */
    public static function retornaQuerySearchTransportadora()
    {

        $sql = "SELECT PARCNEGOCIO.* FROM (SELECT PN.NMSECUNDARIPARC as NMRAZSOCTRAN, PN.NRINSCRICAOPARC,PA.NRPARCNEGOCIO, PA.NRORG,
                REPLACE(REPLACE(REPLACE(REPLACE(PN.NRINSCRICAOPARC, '.',''),'/',''),'-',''),' ','') AS INSCRICAO
                FROM PARCNEGOCIO PN
                INNER JOIN PARCERIA PA
                ON PN.NRPARCNEGOCIO = PA.NRPARCNEGOCIO
                AND PN.NRORG = PA.NRORG
                INNER JOIN FORNECEDOR F ON (F.NRPARCNEGOCIO = PA.NRPARCNEGOCIO AND F.NRORG = PA.NRORG)
                INNER JOIN TRANSPORT T ON (F.CDFORNECED = T.CDFORNECED AND PN.NRORG = T.NRORG)
                WHERE PA.CDTIPOPARCEIRO = 'FORNECEDOR') PARCNEGOCIO ORDER BY 1";

        return $sql;
    }

     /**
     * Retorna registro de interlocutor.
     *
     * @param integer $nrparc N?o do Parceiro de Neg?.
     * @param integer $nrorg      N?o da Organiza?.
     * @param integer $nrparcrelac Numero do relacionamento
     *
     * @return array
     *
     * @author gustavosilva - 18/05/2012
     */
    public static function consultaInterlocutor($nrparc, $nrorg, $nrparcrelac)
    {
        $query = self::retornaQuerySearchInterlocutor();
        $db = \Setforms2\Runtime\Connection::getInstance();
        $query .= ' WHERE NRPARCNEGOCIO = ? AND NRORG = ? AND NRPARCNEGRELAC = ?';
        $array = $db->fetchAll($query,array($nrparc, $nrorg, $nrparcrelac));
        return $array;
    }

    public static function filtroAssistente($selectTipoParceiro, $innerTipoParceiro, $where)
    {
        $select = "SELECT PN.NRPARCNEGOCIO,
                       PN.NMPRINCIPALPARC,
                       PN.NMSECUNDARIPARC,
                       PN.CDSEGMER,
                       PN.NRINSCRICAOPARC,
                       PN.CDTIPOPARCPRINCIPAL,
                       EP.CDPAIS,
                       EP.SGESTADO,
                       EP.CDMUNICIPIO,
                       EP.CDBAIRRO,
                       EP.NMBAIRROENDERECO,
                       $selectTipoParceiro
                FROM PARCNEGOCIO PN
                $innerTipoParceiro
                INNER JOIN ENDERECOPARC EP ON (PN.NRPARCNEGOCIO = EP.NRPARCNEGOCIO
                        AND PN.NRORG = EP.NRORG)
                $where
                ORDER BY PN.NMPRINCIPALPARC";

        return $select;
    }

    /**
     *
     */
    public function preInsert($event)
    {
        parent::preInsert($event);
        $strategy_0 = new GeraIdAlfanumericoStrategy("NRORG = @\Geral\Util\Ambiente::getNrorgTrabalho()@ AND CDTIPOINSCRICAO = 'LIVRE'
        AND NRINSCRICAOPARC LIKE 'SN-%',
        20, SN-");
        $strategy_0->setColumnName("NRINSCRICAOPARC");
        $table = "PARCNEGOCIO";
        $strategy_0->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();

        $strategy_0->setTableName($table);
        $strategy_0->setData($this->getDataAsArray());
        $strategy_0->setPkColumns($pkColumns);
        $strategy_0->setColumns($columnMapper);
        $strategy_0->setStep(1);
        $this->NRINSCRICAOPARC = $strategy_0->execute();

        $strategy_1 = new GeraDataStrategy("@now()@");
        $strategy_1->setColumnName("DTINCLUSAO");
        $table = "PARCNEGOCIO";
        $strategy_1->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();
        $strategy_1->setTableName($table);
        $strategy_1->setData($this->getDataAsArray());
        $strategy_1->setPkColumns($pkColumns);
        $strategy_1->setColumns($columnMapper);
        $strategy_1->setStep(0);
        $this->DTINCLUSAO = $strategy_1->execute();

        $strategy_3 = new GeraNrOrgOperadorStrategy("@Geral\Util\Ambiente::getNrorg()@");
        $strategy_3->setColumnName("NRORGINCLUSAO");
        $table = "PARCNEGOCIO";
        $strategy_3->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();

        $strategy_3->setTableName($table);
        $strategy_3->setData($this->getDataAsArray());
        $strategy_3->setPkColumns($pkColumns);
        $strategy_3->setColumns($columnMapper);
        $strategy_3->setStep(0);
        $this->NRORGINCLUSAO = $strategy_3->execute();
        $strategy_4 = new GeraCdOperadorStrategy("@Ambiente::getCdOperador()@");
        $strategy_4->setColumnName("CDOPERINCLUSAO");
        $table = "PARCNEGOCIO";
        $strategy_4->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();

        $strategy_4->setTableName($table);
        $strategy_4->setData($this->getDataAsArray());
        $strategy_4->setPkColumns($pkColumns);
        $strategy_4->setColumns($columnMapper);
        $strategy_4->setStep(0);
        $this->CDOPERINCLUSAO = $strategy_4->execute();
        $strategy_7 = new GeraIdStrategy("NRORG = @\Geral\Util\Ambiente::getNrorgTrabalho()@");
        $strategy_7->setColumnName("NRPARCNEGOCIO");
        $table = "PARCNEGOCIO";
        $strategy_7->setTableName($table);
        $pkColumns = $this->getTable()->getIdentifier();
        $columnMapper = $this->getTable()->getColumnNames();

        $strategy_7->setTableName($table);
        $strategy_7->setData($this->getDataAsArray());
        $strategy_7->setPkColumns($pkColumns);
        $strategy_7->setColumns($columnMapper);
        $strategy_7->setStep(1);
        $this->NRPARCNEGOCIO = $strategy_7->execute();

    }

    /**
     * Retorna a query das chaves, nome e tipo de relacao dos dependentes de um vínculo.
     *
     * @param integer $nrvinculom numero do vinculo, responsavel pelos dependentes.
     * @param integer $nrorg      numero da organizacao do vinculo.
     *
     * @return String
     *
     * @author paulopereira - 20/11/2013
     */
    public static function getParcnegocioDependenteDeVinculo($nrvinculom, $nrorg)
    {
        $sql = "SELECT DEPENDENTES.NRPARCNEGOCIO AS NRPARCDEPENDE, DEPENDENTES.NRORG, DEPENDENTES.NMPRINCIPALPARC, 
                    TIPORELACIONA.NRTIPORELACIONA, TIPORELACIONA.NMTIPORELACIONA
                  FROM PARCNEGOCIO DEPENDENTES
                  INNER JOIN RELACIONAPARC
                    ON DEPENDENTES.NRPARCNEGOCIO = RELACIONAPARC.NRPARCNEGRELAC
                    AND DEPENDENTES.NRORG        = RELACIONAPARC.NRORG
                  INNER JOIN PARCNEGOCIO
                    ON PARCNEGOCIO.NRPARCNEGOCIO = RELACIONAPARC.NRPARCNEGOCIO
                    AND PARCNEGOCIO.NRORG        = RELACIONAPARC.NRORG
                  INNER JOIN GPE_PESSOA
                    ON GPE_PESSOA.NRPARCNEGOCIO  = PARCNEGOCIO.NRPARCNEGOCIO
                    AND GPE_PESSOA.NRORG         = PARCNEGOCIO.NRORG
                  INNER JOIN GPE_VINCULOM
                    ON GPE_VINCULOM.NRPESSOA     = GPE_PESSOA.NRPESSOA
                    AND GPE_VINCULOM.NRORG       = GPE_PESSOA.NRORG
                  INNER JOIN TIPORELACIONA
                    ON TIPORELACIONA.NRTIPORELACIONA = RELACIONAPARC.NRTIPORELACIONA
                    AND (TIPORELACIONA.NRTIPORELACIONA = 3 
                      or TIPORELACIONA.NRTIPORELACIONA = 5
                      or TIPORELACIONA.NRTIPORELACIONA = 6)
                  WHERE GPE_VINCULOM.NRVINCULOM  = $nrvinculom 
                    AND GPE_VINCULOM.NRORG       = $nrorg
                  ORDER BY DEPENDENTES.NMPRINCIPALPARC, TIPORELACIONA.NMTIPORELACIONA";

        return $sql;
    }

}