/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_COMPLEXIDADE                                             */
/* Tabela : COMPLEXIDADE                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 06/11/2008 - Ronald Reis                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_COMPLEXIDADE
BEFORE INSERT OR UPDATE OR DELETE
ON COMPLEXIDADE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCOMPLEX := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCOMPLEXID,0) <> NVL(:NEW.CDCOMPLEXID,0)) OR
         (NVL(:OLD.NMCOMPLEXID,0) <> NVL(:NEW.NMCOMPLEXID,0)) THEN
         :NEW.DTULTATUCOMPLEX := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('COMPLEXIDADE', '', 'CDCOMPLEXID='||:OLD.CDCOMPLEXID||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE COMPLEXIDADE MODIFY DTULTATUCOMPLEX DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_COMPLEXIDADE','5.05.017'); END;
/
